EclipseWtpComponent (Gradle API 2.10)
Date: 2015-12-21

Package: org.gradle.plugins.ide.eclipse.model

## [Groovy] Class EclipseWtpComponent

- org.gradle.plugins.ide.eclipse.model.EclipseWtpComponent

- Enables fine-tuning wtp component details of the Eclipse plugin

  Example of use with a blend of all possible properties. Bear in mind that usually you don't have configure them directly because Gradle configures it for free!

       apply plugin: 'java'
       apply plugin: 'war'
       apply plugin: 'eclipse-wtp'

       configurations {
         someInterestingConfiguration
         anotherConfiguration
       }

       eclipse {

         //if you want parts of paths in resulting file(s) to be replaced by variables (files):
         pathVariables 'GRADLE_HOME': file('/best/software/gradle'), 'TOMCAT_HOME': file('../tomcat')

         wtp {
           component {
             //you can configure the context path:
             contextPath = 'someContextPath'

             //you can configure the deployName:
             deployName = 'killerApp'

             //you can alter the wb-resource elements. sourceDirs is a ConventionProperty.
             //non-existing source dirs won't be added to the component file.
             sourceDirs += file('someExtraFolder')

             //you can alter the files are to be transformed into dependent-module elements:
             plusConfigurations += [ configurations.someInterestingConfiguration ]

             //or whose files are to be excluded from dependent-module elements:
             minusConfigurations << configurations.anotherConfiguration

             //you can add a wb-resource elements; mandatory keys: 'sourcePath', 'deployPath':
             //if sourcePath points to non-existing folder it will *not* be added.
             resource sourcePath: 'extra/resource', deployPath: 'deployment/resource'

             //you can add a wb-property elements; mandatory keys: 'name', 'value':
             property name: 'moodOfTheDay', value: ':-D'
           }
         }
       }

  For tackling edge cases users can perform advanced configuration on resulting XML file. It is also possible to affect the way eclipse plugin merges the existing configuration via beforeMerged and whenMerged closures.

  beforeMerged and whenMerged closures receive WtpComponent object

  Examples of advanced configuration:

       apply plugin: 'java'
       apply plugin: 'war'
       apply plugin: 'eclipse-wtp'

       eclipse {

         wtp {
           component {
             file {
               //if you want to mess with the resulting XML in whatever way you fancy
               withXml {
                 def node = it.asNode()
                 node.appendNode('xml', 'is what I love')
               }

               //closure executed after wtp component file content is loaded from existing file
               //but before gradle build information is merged
               beforeMerged { wtpComponent ->
                 //tinker with WtpComponent here
               }

               //closure executed after wtp component file content is loaded from existing file
               //and after gradle build information is merged
               whenMerged { wtpComponent ->
                 //you can tinker with the WtpComponent here
               }
             }
           }
         }
       }

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `String` | `classesDeployPath` The deploy path for classes.
    `String` | `contextPath` The context path for the web application
    `String` | `deployName` The deploy name to be used.
    `XmlFileContentMerger` | `file` See file(Closure)
    `Set<Configuration>` | `libConfigurations` The configurations whose files are to be transformed into dependent-module elements with a deploy path of #libDeployPath.
    `String` | `libDeployPath` The deploy path for libraries.
    `Set<Configuration>` | `minusConfigurations` The configurations whose files are to be excluded from dependent-module elements.
    `Map<String, File>` | `pathVariables` The variables to be used for replacing absolute path in dependent-module elements.
    `Project` | `project`
    `List<WbProperty>` | `properties` Additional property elements.
    `List<WbResource>` | `resources` ConventionProperty for additional wb-resource elements.
    `Set<Configuration>` | `rootConfigurations` The configurations whose files are to be transformed into dependent-module elements with a deploy path of '/'.
    `Set<File>` | `sourceDirs` ConventionProperty for the source directories to be transformed into wb-resource elements.

  - ### Constructor Summary

    Constructors
    Constructor and description
    `EclipseWtpComponent (Project project, XmlFileContentMerger file)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `file(groovy.lang.Closure closure)` Enables advanced configuration like tinkering with the output XML or affecting the way existing wtp component file content is merged with gradle build information
    `org.gradle.plugins.ide.eclipse.model.internal.FileReferenceFactory` | `getFileReferenceFactory()`
    `Set<Configuration>` | `getPlusConfigurations()` Synonym for libConfigurations.
    `void` | `mergeXmlComponent(WtpComponent xmlComponent)`
    `void` | `property(Map<String, String> args)` Adds a property.
    `void` | `resource(Map<String, String> args)` Adds a wb-resource.
    `void` | `setPlusConfigurations(Set<Configuration> plusConfigurations)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Property Detail

    - #### String classesDeployPath

      The deploy path for classes.

      For examples see docs for EclipseWtp

    - #### String contextPath

      The context path for the web application

      For examples see docs for EclipseWtp

    - #### String deployName

      The deploy name to be used.

      For examples see docs for EclipseWtp

    - #### final XmlFileContentMerger file

      See file(Closure)

    - #### Set<Configuration> libConfigurations

      The configurations whose files are to be transformed into dependent-module elements with a deploy path of #libDeployPath.

      For examples see docs for EclipseWtp

    - #### String libDeployPath

      The deploy path for libraries.

      For examples see docs for EclipseWtp

    - #### Set<Configuration> minusConfigurations

      The configurations whose files are to be excluded from dependent-module elements.

      For examples see docs for EclipseWtp

    - #### Map<String, File> pathVariables

      The variables to be used for replacing absolute path in dependent-module elements.

      For examples see docs for EclipseModel

    - #### final Project project

    - #### List<WbProperty> properties

      Additional property elements.

      For examples see docs for EclipseWtp

    - #### List<WbResource> resources

      ConventionProperty for additional wb-resource elements.

      For examples see docs for EclipseWtp

      Only resources that link to an existing directory (`WbResource#sourcePath`) will be added to the wtp component file. The reason is that non-existing resource directory declarations lead to errors when project is imported into Eclipse.

    - #### Set<Configuration> rootConfigurations

      The configurations whose files are to be transformed into dependent-module elements with a deploy path of '/'.

      For examples see docs for EclipseWtp

    - #### Set<File> sourceDirs

      ConventionProperty for the source directories to be transformed into wb-resource elements.

      For examples see docs for EclipseWtp

      Only source dirs that exist will be added to the wtp component file. Non-existing resource directory declarations lead to errors when project is imported into Eclipse.

  - ### Constructor Detail

    - #### EclipseWtpComponent(Project project, XmlFileContentMerger file)

  - ### Method Detail

    - #### void file(groovy.lang.Closure closure)

      Enables advanced configuration like tinkering with the output XML or affecting the way existing wtp component file content is merged with gradle build information

      The object passed to whenMerged{} and beforeMerged{} closures is of type WtpComponent

      For example see docs for EclipseWtpComponent

    - #### org.gradle.plugins.ide.eclipse.model.internal.FileReferenceFactory getFileReferenceFactory()

    - #### Set<Configuration> getPlusConfigurations()

      Synonym for libConfigurations.

    - #### void mergeXmlComponent(WtpComponent xmlComponent)

    - #### void property(Map<String, String> args)

      Adds a property.

      For examples see docs for EclipseWtp

      Parameters:
        `args` - A map that must contain a 'name' and 'value' key with corresponding values.

    - #### void resource(Map<String, String> args)

      Adds a wb-resource.

      For examples see docs for EclipseWtp

      Parameters:
        `args` - A map that must contain a deployPath and sourcePath key with corresponding values.

    - #### void setPlusConfigurations(Set<Configuration> plusConfigurations)